<?php

namespace Controllers;

use Zeedhi\Framework\DTO\Request\Filter;
use Zeedhi\Framework\DTO\Response;
use Services\ApprovalWorkflowService;
use Util\SupUtilities;

/**
 * Abstração do dataSource 'graficoOrcamento' criada para executar a chamada
 * da procedure CONSISTE_ORCAMENTO_GOP antes de exibir o gráfico no Approve,
 * de forma que autalize os valores no orçamento.
 */
class GraficoOrcamentoController extends \Teknisa\GER\Controllers\TeknisaCrud
{
    protected $dataSourceName = 'graficoOrcamento';
    
    public function __construct($crudService, $parameterBag, ApprovalWorkflowService $approvalService, SupUtilities $utilities)
    {
        parent::__construct($crudService, $parameterBag);
        
        $this->approvalService = $approvalService;
        $this->utilities = $utilities;
    }
    
    public function find(Filter $request, Response $response)
    {
        $parameters = $this->utilities->getParametersFromCondititions($request);
        
        $this->approvalService->executeConsisteOrcamentoGOP($parameters);
        
        parent::find($request, $response);
    }
}
