/* Sistemas Integrados TECNISA

Nome: LOG_CTRLAIDF.SQL

Descrio:
   Trigger para gravar o log das alteraes

Criao:
   26/09/2012 - Joo Guilherme Maciel
*/
CREATE OR REPLACE TRIGGER LOG_CTRLAIDF
AFTER DELETE OR INSERT OR UPDATE
ON CTRLAIDF FOR EACH ROW
DECLARE
   V_DSREMOTEADDR VARCHAR2(15);
   V_DSREMOTEHOST VARCHAR2(15);
   V_DSSERVERRDM  VARCHAR2(20);
   V_DSSERVMETHOD VARCHAR2(30);
   V_DSREMOTEOPER VARCHAR2(12);
   V_DESC         VARCHAR2(500);
   V_ITPESQ       VARCHAR2(40);
   V_NMOPERADOR   VARCHAR2(40);
   V_IDTIPOOPER   VARCHAR2(1);
BEGIN
   V_DESC         := '';
   V_ITPESQ       := '';
   V_NMOPERADOR   := '';
   V_IDTIPOOPER   := '';
   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);
   IF DELETING THEN
      IF :OLD.CDEMPRESA IS NOT NULL THEN
         V_DESC := V_DESC || ' Empresa=' || :OLD.CDEMPRESA;
      END IF;
      IF :OLD.CDINSCESTA IS NOT NULL THEN
         V_DESC := V_DESC || ' InscrEstad=' || :OLD.CDINSCESTA;
      END IF;
      IF :OLD.CDMODDOCFISC IS NOT NULL THEN
         V_DESC := V_DESC || ' ModDocFisc=' || :OLD.CDMODDOCFISC;
      END IF;
      IF :OLD.CDCTRLAIDF IS NOT NULL THEN
         V_DESC := V_DESC || ' CdCtrlAIDF=' || :OLD.CDCTRLAIDF;
      END IF;
      IF :OLD.DSCTRLAIDF IS NOT NULL THEN
         V_DESC := V_DESC || ' DescAIDF=' || :OLD.DSCTRLAIDF;
      END IF;
      IF :OLD.NRNFINICIAL IS NOT NULL THEN
         V_DESC := V_DESC || ' NumInicial=' || :OLD.NRNFINICIAL;
      END IF;
      IF :OLD.NRNFFINAL IS NOT NULL THEN
         V_DESC := V_DESC || ' NumFinal=' || :OLD.NRNFFINAL;
      END IF;
      IF :OLD.QTTALOES IS NOT NULL THEN
         V_DESC := V_DESC || ' QtdTaloes=' || :OLD.QTTALOES;
      END IF;
      IF :OLD.NRTALOES IS NOT NULL THEN
         V_DESC := V_DESC || ' NRTaloes=' || :OLD.NRTALOES;
      END IF;
      IF :OLD.NRUSADOS IS NOT NULL THEN
         V_DESC := V_DESC || ' TaloesUsados=' || :OLD.NRUSADOS;
      END IF;
      IF :OLD.IDBLOQAIDF IS NOT NULL THEN
         V_DESC := V_DESC || ' IdBloqAidf=' || :OLD.IDBLOQAIDF;
      END IF;

      V_ITPESQ       := :OLD.CDEMPRESA||:OLD.CDINSCESTA||:OLD.CDMODDOCFISC||:OLD.CDCTRLAIDF;
      V_IDTIPOOPER   := '3';
   ELSE
      IF UPDATING THEN
            IF NVL(:NEW.CDEMPRESA, '!')    <> NVL(:OLD.CDEMPRESA, '!')      OR
               NVL(:NEW.CDINSCESTA, '!')   <> NVL(:OLD.CDINSCESTA, '!')     OR
               NVL(:NEW.CDMODDOCFISC, '!') <> NVL(:OLD.CDMODDOCFISC, '!')   OR
               NVL(:NEW.CDCTRLAIDF, '!')   <> NVL(:OLD.CDCTRLAIDF, '!')     OR
               NVL(:NEW.DSCTRLAIDF, '!')   <> NVL(:OLD.DSCTRLAIDF, '!')     OR
               NVL(:NEW.NRNFINICIAL, '!')  <> NVL(:OLD.NRNFINICIAL, '!')    OR
               NVL(:NEW.NRNFFINAL, '!')    <> NVL(:OLD.NRNFFINAL, '!')      OR
               NVL(:NEW.QTTALOES, -1)      <> NVL(:OLD.QTTALOES, -1)        OR
               NVL(:NEW.NRTALOES, -1)      <> NVL(:OLD.NRTALOES, -1)        OR
               NVL(:NEW.NRUSADOS, -1)      <> NVL(:OLD.NRUSADOS, -1)        OR
               NVL(:NEW.IDBLOQAIDF, '!')   <> NVL(:OLD.IDBLOQAIDF, '!')    THEN
            V_ITPESQ       := :OLD.CDEMPRESA||:OLD.CDINSCESTA||:OLD.CDMODDOCFISC||:OLD.CDCTRLAIDF;
            V_IDTIPOOPER   := '2';
         END IF;
      ELSE
         V_ITPESQ       := :NEW.CDEMPRESA||:NEW.CDINSCESTA||:NEW.CDMODDOCFISC||:NEW.CDCTRLAIDF;
         V_IDTIPOOPER   := '1';
      END IF;
      IF NVL(:NEW.CDEMPRESA, '!')    <> NVL(:OLD.CDEMPRESA, '!') THEN
         V_DESC := V_DESC || ' Empresa=' || :NEW.CDEMPRESA;
      END IF;
            IF NVL(:NEW.CDINSCESTA, '!')   <> NVL(:OLD.CDINSCESTA, '!') THEN
         V_DESC := V_DESC || ' InscrEstad=' || :NEW.CDINSCESTA;
      END IF;
            IF NVL(:NEW.CDMODDOCFISC, '!') <> NVL(:OLD.CDMODDOCFISC, '!') THEN
         V_DESC := V_DESC || ' ModDocFisc=' || :NEW.CDMODDOCFISC;
      END IF;
            IF NVL(:NEW.CDCTRLAIDF, '!')   <> NVL(:OLD.CDCTRLAIDF, '!') THEN
         V_DESC := V_DESC || ' CdCtrlAIDF=' || :NEW.CDCTRLAIDF;
      END IF;
            IF NVL(:NEW.DSCTRLAIDF, '!')   <> NVL(:OLD.DSCTRLAIDF, '!') THEN
         V_DESC := V_DESC || ' DescAIDF=' || :NEW.DSCTRLAIDF;
      END IF;
            IF NVL(:NEW.NRNFINICIAL, '!')  <> NVL(:OLD.NRNFINICIAL, '!') THEN
         V_DESC := V_DESC || ' NumInicial=' || :NEW.NRNFINICIAL;
      END IF;
            IF NVL(:NEW.NRNFFINAL, '!')    <> NVL(:OLD.NRNFFINAL, '!') THEN
         V_DESC := V_DESC || ' NumFinal=' || :NEW.NRNFFINAL;
      END IF;
            IF NVL(:NEW.QTTALOES, -1)      <> NVL(:OLD.QTTALOES, -1) THEN
         V_DESC := V_DESC || ' QtdTaloes=' || :NEW.QTTALOES;
      END IF;
           IF NVL(:NEW.NRTALOES, -1)      <> NVL(:OLD.NRTALOES, -1) THEN
         V_DESC := V_DESC || ' NRTaloes=' || :NEW.NRTALOES;
      END IF;
            IF NVL(:NEW.NRUSADOS, -1)      <> NVL(:OLD.NRUSADOS, -1) THEN
         V_DESC := V_DESC || ' TaloesUsados=' || :NEW.NRUSADOS;
      END IF;
            IF NVL(:NEW.IDBLOQAIDF, '!')  <> NVL(:OLD.IDBLOQAIDF, '!') THEN
         V_DESC := V_DESC || ' IdBloqAidf=' || :NEW.IDBLOQAIDF;
      END IF;

   END IF;
   IF (V_DESC IS NOT NULL) AND (V_IDTIPOOPER IS NOT NULL) THEN
      INSERT INTO LOGOPERA
         (NMTABELA,
          DTOPERACAO,
          NMRESPOPER,
          IDTIPOOPER,
          DSOPERACAO,
          CDPESQITEM,
          DSRDMUSUOPER,
          DSENDUSUOPER,
          DSNMUSUOPER,
          DSMETUSUOPER,
          CDORESPOPER)
       VALUES
         ('CTRLAIDF',
          SYSDATE,
          NVL(V_NMOPERADOR,' '),
          V_IDTIPOOPER,
          SUBSTR(V_DESC, 1, 300),
          V_ITPESQ,
          V_DSSERVERRDM,
          V_DSREMOTEADDR,
          V_DSREMOTEHOST,
          V_DSSERVMETHOD,
          V_DSREMOTEOPER);
   END IF;
END;
/
-- VERSAO --
BEGIN ATUVEROBJ('LOG_CTRLAIDF','5.50.xxx'); END;
/

