/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_TIPOINSU                                                 */
/* Tabela : TIPOINSU                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 04/05/2007 - Ronald Reis                                                   */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_TIPOINSU'  and
            type = 'TR'                   and
            u.uid = o.uid                 and
            u.name = USER)
   DROP TRIGGER DTULTATU_TIPOINSU
GO

CREATE TRIGGER DTULTATU_TIPOINSU
ON TIPOINSU
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'TIPOINSU', '', 'CDTIPOINSU='+ CDTIPOINSU +';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE TIPOINSU
      SET DTULTATUTINS = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(TIPOINSU.CDTIPOINSU,0) = ISNULL(INSERTED.CDTIPOINSU,0));
   END;
END;
GO


-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_TIPOINSU','4.11.134';
GO
