IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
          WHERE
            O.NAME = 'ATUALIZA_PAREXPEDICAO_PDR' AND
            TYPE = 'P'                  AND
            U.UID = O.UID               AND
            U.NAME = USER)
   DROP PROCEDURE ATUALIZA_PAREXPEDICAO_PDR
GO

CREATE
PROCEDURE ATUALIZA_PAREXPEDICAO_PDR
   @P_CDFILIAL   VARCHAR(4)
AS
   DECLARE @V_UPDATE_TEXT             NVARCHAR(4000);
   DECLARE @V_INSERT_TEXT             NVARCHAR(4000);
   DECLARE @V_CDFILIAL_PADRAO         VARCHAR(4);
   DECLARE @V_CDFILIAL                VARCHAR(4);
   DECLARE @V_NAME                    VARCHAR(50);
   DECLARE @V_CDFILIALREL             VARCHAR(4);
BEGIN
   BEGIN TRANSACTION;
   SELECT @V_CDFILIAL_PADRAO = MAX(CDFILIPADRAO)
   FROM PARAMGERAL;
   /*VERIFICA SE EXISTE FILIAL PADRAO PARAMETRIZADA*/
   IF (@V_CDFILIAL_PADRAO) IS NOT NULL BEGIN
      /*SELECIONA TODAS AS FILIAIS QUE UTILIZAM A PARAMETRIZAO POR FILIAL PADRAO DA TABELA 'PAREXPEDICAO'*/
      DECLARE C_INSPARAMEXP CURSOR FOR
         (SELECT CDFILIAL
            FROM PARAMFILIPADR
           WHERE IDTABPARAMFILI = 'S'
             AND NMTABPARAMFILI = 'PAREXPEDICAO'
             AND CDFILIAL <> @V_CDFILIAL_PADRAO
             AND CDFILIAL = ISNULL(@P_CDFILIAL, CDFILIAL));
      OPEN C_INSPARAMEXP;
      FETCH NEXT FROM C_INSPARAMEXP INTO
      @V_CDFILIAL

      WHILE (@@FETCH_STATUS = 0) BEGIN

         SET @V_UPDATE_TEXT = 'INSERT INTO PAREXPEDICAO (';
         SET @V_INSERT_TEXT = '(SELECT ';

         /*SELECIONA OS NOMES DAS COLUNAS DAS TABELA 'PAREXPEDICAO'*/

         DECLARE C_CAMPO CURSOR FOR (SELECT C.NAME
                                       FROM SYSOBJECTS O, SYSCOLUMNS C
                                      WHERE O.ID = C.ID
                                        AND O.NAME = 'PAREXPEDICAO'
                                        AND C.NAME <> 'CDFILIAL')
         OPEN C_CAMPO;
         FETCH NEXT FROM C_CAMPO INTO
            @V_NAME
         WHILE (@@FETCH_STATUS = 0) BEGIN
            SET @V_UPDATE_TEXT = @V_UPDATE_TEXT +@V_NAME+  ', ';
            SET @V_INSERT_TEXT = @V_INSERT_TEXT +@V_NAME+  ', ';
            FETCH NEXT FROM C_CAMPO INTO
            @V_NAME
         END;
         CLOSE C_CAMPO;
         DEALLOCATE C_CAMPO;
         /*DELETA A OS PARAMETROS DA FILIAL QUE UTILIZA PARAMETRIZAO PELA PADRO*/
         DELETE FROM PAREXPEDICAO
         WHERE CDFILIAL = @V_CDFILIAL;


         SET @V_UPDATE_TEXT = @V_UPDATE_TEXT+ 'CDFILIAL) ';
         SET @V_INSERT_TEXT = @V_INSERT_TEXT+ '''' +@V_CDFILIAL+''''+' ';

         SET @V_INSERT_TEXT = @V_INSERT_TEXT + 'FROM PAREXPEDICAO ';
         SET @V_INSERT_TEXT = @V_INSERT_TEXT + 'WHERE CDFILIAL = '+'''' +@V_CDFILIAL_PADRAO+ '''' + ')';
         SET @V_UPDATE_TEXT = @V_UPDATE_TEXT + @V_INSERT_TEXT;

         EXECUTE SP_EXECUTESQL @V_UPDATE_TEXT;

         FETCH NEXT FROM C_INSPARAMEXP INTO
         @V_CDFILIAL;
      END;
      CLOSE C_INSPARAMEXP;
      DEALLOCATE C_INSPARAMEXP;
   END;
   COMMIT TRANSACTION;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'ATUALIZA_PAREXPEDICAO_PDR','5.07.006';
GO
